# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Version(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'darwin_x64': 'str',
        'linux_x64': 'str',
        'windows_x64': 'str'
    }

    attribute_map = {
        'darwin_x64': 'darwinX64',
        'linux_x64': 'linuxX64',
        'windows_x64': 'windowsX64'
    }

    def __init__(self, darwin_x64=None, linux_x64=None, windows_x64=None):  # noqa: E501
        """Version - a model defined in Swagger"""  # noqa: E501
        self._darwin_x64 = None
        self._linux_x64 = None
        self._windows_x64 = None
        self.discriminator = None
        if darwin_x64 is not None:
            self.darwin_x64 = darwin_x64
        if linux_x64 is not None:
            self.linux_x64 = linux_x64
        if windows_x64 is not None:
            self.windows_x64 = windows_x64

    @property
    def darwin_x64(self):
        """Gets the darwin_x64 of this Version.  # noqa: E501


        :return: The darwin_x64 of this Version.  # noqa: E501
        :rtype: str
        """
        return self._darwin_x64

    @darwin_x64.setter
    def darwin_x64(self, darwin_x64):
        """Sets the darwin_x64 of this Version.


        :param darwin_x64: The darwin_x64 of this Version.  # noqa: E501
        :type: str
        """

        self._darwin_x64 = darwin_x64

    @property
    def linux_x64(self):
        """Gets the linux_x64 of this Version.  # noqa: E501


        :return: The linux_x64 of this Version.  # noqa: E501
        :rtype: str
        """
        return self._linux_x64

    @linux_x64.setter
    def linux_x64(self, linux_x64):
        """Sets the linux_x64 of this Version.


        :param linux_x64: The linux_x64 of this Version.  # noqa: E501
        :type: str
        """

        self._linux_x64 = linux_x64

    @property
    def windows_x64(self):
        """Gets the windows_x64 of this Version.  # noqa: E501


        :return: The windows_x64 of this Version.  # noqa: E501
        :rtype: str
        """
        return self._windows_x64

    @windows_x64.setter
    def windows_x64(self, windows_x64):
        """Sets the windows_x64 of this Version.


        :param windows_x64: The windows_x64 of this Version.  # noqa: E501
        :type: str
        """

        self._windows_x64 = windows_x64

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Version, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Version):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
